<?php
namespace Test;

use design\Memento\State;
use design\Memento\Ticket;

class MementoTest extends \PHPUnit_Framework_TestCase
{

    public function testOpenTicketAssignAndSetBackToOpen()
    {
        $ticket = new Ticket();
        // open the ticket
        $ticket->open();
        $openedState = $ticket->getState();
        $this->assertEquals(State::STATE_OPENED, (string) $ticket->getState());
        $memento = $ticket->saveToMemento();
        // assign the ticket
        $ticket->assign();
        $this->assertEquals(State::STATE_ASSIGNED, (string) $ticket->getState());
        // now restore to the opened state, but verify that the state object has been cloned for the memento
        $ticket->restoreFromMemento($memento);
        $this->assertEquals(State::STATE_OPENED, (string) $ticket->getState());
        $this->assertNotSame($openedState, $ticket->getState());
    }
}
